/* ---------------------------------------------------------------------------
   A. Veneziani -  Esempio base d'uso degli oggetti ad allocazione dinamica
  --------------------------------------------------------------------------- */

#include "conio.h"
#include <iostream>

using namespace std;

// dichiara una semplice classe i cui oggetti
// verranno in questo caso istanziati in modo dinamico
class Intero {

    int n;     // numero intero rappresentato (interno all'oggetto)

    // metodi della classe
    public:
    // assegnazione di un valore
    void assegna(int v)
    {
        n = v;
    }

    // somma di due interi
    // (oggetto corrente e numero passato come parametro al metodo)
    // con reso del risulato
    int somma(int v)
    {
       return(n + v);
    }

    // lettura del contenuto dell' oggetto
    // (numero intero)
    int leggi()
    {
        return(n);
    }
};


int main(int argc, char* argv[])
{
    Intero *i1;   // dichiara un puntatore al tipo di oggetto

    // istanzia dinamicamente l'oggetto e vi accede tramite
    // il puntatore anzidetto
    i1 = new Intero();

    // alcune semplici usi dei metodi della classe Intero
    i1->assegna(3);
    i1->assegna(i1->somma(5));
    cout << "Il risultato e':  " << i1->leggi();

    getch();

    return 0;
}
//---------------------------------------------------------------------------

